# fm  FilterMotor controller
# 2006Feb12 JDM Initiation
# 2008Jun09 JDM trying to finish..... using sockets instead of serial.

#!/usr/bin/python
'''Menu

This example demonstrates the use of various menu types in gtk.  It
demonstrates the new submenu navigation and scrolling menu features of
gtk 2.0.'''

import gtk
import time
import socket
import fm_defaults as fmd
import common

def create_menu(depth, length=5):
    if depth < 1:
        return None

    menu = gtk.Menu()
    group= None

    for i in range(length):
        menuitem = gtk.RadioMenuItem(group, 'item %2d - %d' % (depth, i))
        group = menuitem
        menu.add(menuitem)
        menuitem.show()
        if depth > 1:
            submenu = create_menu(depth - 1)
            menuitem.set_submenu(submenu)
    return menu


class fm(gtk.Window):
    def __init__(self, parent=None):
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title('Filter Controller')
        #self.__class__.__name__)

        vbox = gtk.VBox()
        self.add(vbox)

        menubar = gtk.MenuBar()
        vbox.pack_start(menubar, expand=False)
################# SETUP MIRC #####################################
        menuitem = gtk.MenuItem('MIRC')
# based on create_menu call
        submenu=gtk.Menu()

        submenuitem=gtk.MenuItem(fmd.mirc_init)
        submenuitem.connect("activate",self.initf_cb,'MIRC')
        submenu.add(submenuitem)
        submenuitem.show()   # what does this do?

        menuitem.set_submenu(submenu)
        menubar.add(menuitem)

####################  END MIRC PULL DOWN MENU #######################

####################  END CHAMP PULL DOWN MENU #######################
        menuitem = gtk.MenuItem('CHAMP')

# based on create_menu call
        submenu=gtk.Menu()

        submenuitem=gtk.MenuItem(fmd.champ_init)
        submenuitem.connect("activate",self.initf_cb,'CHAMP')
        submenu.add(submenuitem)
        submenuitem.show()   # what does this do?

        menuitem.set_submenu(submenu)
        menubar.add(menuitem)

#        menuitem.set_right_justified(True)
 ####################  END CHAMP PULL DOWN MENU #######################

## put in pull-down menu callbacks

        
        vbox2 = gtk.VBox(spacing=10)
        vbox2.set_border_width(10)
        vbox.pack_start(vbox2)
        
        table = gtk.Table(4, 7, False)
        table.set_row_spacings(10)
        table.set_col_spacings(20)
        vbox2.pack_start(table, False, False, 0)

   
        label = gtk.Label("MIRC")
        label.set_pattern('____________________________')
        table.attach(label, 0, 1, 1, 3)

        label = gtk.Label("CHAMP")
        label.set_pattern('____________________________')
        table.attach(label, 0, 1, 4, 6)

        label = gtk.Label("Filterwheel 1")
        label.set_pattern('____________________________')
        table.attach(label, 1, 2, 0, 1)

        label = gtk.Label("Filterwheel 2")
        label.set_pattern('____________________________')
        table.attach(label, 2, 3, 0, 1)

        label = gtk.Label("Status")
        label.set_pattern('____________________________')
        table.attach(label, 3, 4, 0, 1)

        #MIRC
        label = gtk.Label("Undefined")
        label.set_use_underline(True)
        table.attach(label,1,2,1,2)
        self.id_mirc_currentfilter1 = label

        label = gtk.Label("0")
        label.set_use_underline(True)
        table.attach(label,1,2,2,3)
        self.id_mirc_currentpos1 = label

        label = gtk.Label("Undefined")
        label.set_use_underline(True)
        table.attach(label,2,3,1,2)
        self.id_mirc_currentfilter2 = label

        label = gtk.Label("0")
        label.set_use_underline(True)
        table.attach(label,2,3,2,3)
        self.id_mirc_currentpos2 = label

        label = gtk.Label(" ")
        label.set_use_underline(True)
        table.attach(label,3,4,1,3)
        self.id_mirc_status1 = label


        #CHAMP
        label = gtk.Label("Undefined")
        label.set_use_underline(True)
        table.attach(label,1,2,4,5)  #1,2,1,2
        self.id_champ_currentfilter1 = label

        label = gtk.Label("0")
        label.set_use_underline(True)
        table.attach(label,1,2,5,6)   #1,2,2,3
        self.id_champ_currentpos1 = label

        label = gtk.Label("Undefined")
        label.set_use_underline(True)
        table.attach(label,2,3,4,5)  #2,3,1,2
        self.id_champ_currentfilter2 = label

        label = gtk.Label("0")
        label.set_use_underline(True)
        table.attach(label,2,3,5,6)  #2,3,2,3
        self.id_champ_currentpos2 = label

        label = gtk.Label(" ")
        label.set_use_underline(True)
        table.attach(label,3,4,4,6)  #3,4,1,3
        self.id_champ_status1 = label

        combo_box = gtk.combo_box_new_text()
        combo_box.set_wrap_width(1)
        for i in range(8):
            if (i == 0):
                combo_box.append_text('')
            else:
                combo_box.append_text(fmd.mirc1[i-1])
                combo_box.connect("changed", self.movef_combo,'MIRC','1',i-1)
        combo_box.set_active(0)
        table.attach(combo_box,1,2,3,4)
        self.id_combo_mirc1 = combo_box


        combo_box = gtk.combo_box_new_text()
        combo_box.set_wrap_width(1)
        for i in range(8):
            if (i == 0):
                combo_box.append_text('')
            else:
                combo_box.append_text(fmd.mirc2[i-1])
                combo_box.connect("changed", self.movef_combo,'MIRC','2',i-1)
        combo_box.set_active(0)
        table.attach(combo_box,2,3,3,4)
        self.id_combo_mirc2 = combo_box

        combo_box = gtk.combo_box_new_text()
        combo_box.set_wrap_width(1)
        for i in range(6):
            if (i == 0):
                combo_box.append_text('')
            else:
                combo_box.append_text(fmd.champ1[i-1])
                combo_box.connect("changed", self.movef_combo,'CHAMP','1',i-1)
        combo_box.set_active(0)
        table.attach(combo_box,1,2,6,7)
        self.id_combo_champ1 = combo_box

        combo_box = gtk.combo_box_new_text()
        combo_box.set_wrap_width(1)
        for i in range(6):
            if (i == 0):
                combo_box.append_text('')
            else:
                combo_box.append_text(fmd.champ2[i-1])
                combo_box.connect("changed", self.movef_combo,'CHAMP','2',i-1)
        combo_box.set_active(0)
        table.attach(combo_box,2,3,6,7)
        self.id_combo_champ2 = combo_box


        separator = gtk.HSeparator()
        vbox.pack_start(separator, expand=False)

        vbox2 = gtk.VBox(spacing=10)
        vbox2.set_border_width(10)
        vbox.pack_start(vbox2, expand=False)

        button = gtk.Button('close')
        button.connect('clicked', lambda button, w=self: w.destroy())
        vbox2.pack_start(button)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

        self.show_all()

        self.newPosi = ['0', '0']
        self.initf_cb(0,"MIRC") 
        self.initf_cb(0,"CHAMP")

        #move to the standard positions
        self.id_combo_mirc1.set_active(fmd.startingFiltermirc1)
        self.id_combo_mirc2.set_active(fmd.startingFiltermirc2)
        self.id_combo_champ1.set_active(fmd.startingFilterchamp1)
        self.id_combo_champ2.set_active(fmd.startingFilterchamp2)
        
    def movef_cb(self,widget,cam,fwheel,pos):
        if (cam == "MIRC"):
                print "Addressing MIRC Camera, "
                if (fwheel == "1"):
                    print "Filterwheel 1, "
                    print "Pos = ",pos
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_mirc_status1.set_text("Homing...")
			common.mircF.homeFilters(1)		
                        fmd.mirc_currentpos1= 0
                        fmd.mirc_currentfilter1= "HOME"
                        self.id_mirc_currentfilter1.set_text(fmd.mirc_currentfilter1)
                        self.id_mirc_currentpos1.set_text(str(fmd.mirc_currentpos1))
                        self.id_mirc_status1.set_text("")
                        # rest of code
                    if (pos > 0):
                        if pos == 7:                            
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="1D%s\r1G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
			    common.mircF.moveFilters(1,self.newPosi[int(fwheel)-1])
			    fmd.mirc_currentpos1 = self.newPosi[int(fwheel)-1]
                            fmd.mirc_currentfilter1=fmd.mirc1[pos]
			    self.id_mirc_status1.set_text("")
			    self.id_mirc_currentpos1.set_text(str(self.newPosi[int(fwheel)-1]))
			    self.id_mirc_currentfilter1.set_text(fmd.mirc_currentfilter1)
                        else:
                            print fmd.mirc1[pos]
			    print fmd.mirc_filter1[pos-1]
                            ser_string="1D%s\r1G\r" % str(fmd.mirc_filter1[pos-1])
			    print ser_string
			    common.mircF.moveFilters(1,fmd.mirc_filter1[pos-1])
			    self.id_mirc_status1.set_text("")
                            fmd.mirc_currentpos1 = fmd.mirc_filter1[pos-1]
                            fmd.mirc_currentfilter1=fmd.mirc1[pos]
                            self.id_mirc_currentfilter1.set_text(fmd.mirc_currentfilter1)
                            self.id_mirc_currentpos1.set_text(str(fmd.mirc_currentpos1))
                            

                if (fwheel == "2"):
                    print "Filterwheel 2, "
                    print "Pos = ",pos
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_mirc_status1.set_text("Homing...")
                        common.mircF.homeFilters(2)
                        fmd.mirc_currentpos2= 0
                        fmd.mirc_currentfilter2= "HOME"
                        self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                        self.id_mirc_currentpos2.set_text(str(fmd.mirc_currentpos2))
                        self.id_mirc_status1.set_text("")
                        # rest of code
                    if (pos > 0):
                        if pos == 7:
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="2D%s\r2G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
                            common.mircF.moveFilters(2,self.newPosi[int(fwheel)-1])
                            fmd.mirc_currentpos2 = self.newPosi[int(fwheel)-1]
                            fmd.mirc_currentfilter2=fmd.mirc2[pos]
                            self.id_mirc_status1.set_text("")
                            self.id_mirc_currentpos2.set_text(str(self.newPosi[int(fwheel)-1]))
                            self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                        else:
                            print fmd.mirc2[pos]
                            print fmd.mirc_filter2[pos-1]
                            ser_string="2D%s\r2G\r" % str(fmd.mirc_filter1[pos-1])
                            print ser_string
                            common.mircF.moveFilters(2,fmd.mirc_filter2[pos-1])
                            self.id_mirc_status1.set_text("")
                            fmd.mirc_currentpos2 = fmd.mirc_filter2[pos-1]
                            fmd.mirc_currentfilter2=fmd.mirc2[pos]
                            self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                            self.id_mirc_currentpos2.set_text(str(fmd.mirc_currentpos2))


                if (fwheel == "3"):
                    print "Filterwheel 2, "
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_mirc_status1.set_text("Homing...")
                        common.mircF.homeFilters(2)
                        fmd.mirc_currentpos2= 0
                        fmd.mirc_currentfilter2= "HOME"
                        self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                        self.id_mirc_currentpos2.set_text(str(fmd.mirc_currentpos2))
                        self.id_mirc_status1.set_text("")
                        # rest of code
                        
                    if (pos > 0):
                        print fmd.mirc2[pos]
                        if pos == 7:                            
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="2D%s\r2G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
                            mirc_port.write(ser_string)
                            mirc_port.write("2LF\r\n")
                            print mirc_port.readline()
                            print mirc_port.readline()
                            mirc_port.write("2PR\r\n")
                            print mirc_port.readline()
                            print mirc_port.read(13)
                        else:
                            ser_string="2D%s\r2G\r" % str(fmd.mirc_filter2[pos-1])
                            mirc_port.write(ser_string)
                            fmd.mirc_currentpos2 = fmd.mirc_filter2[pos-1]
                            fmd.mirc_currentfilter2=fmd.mirc2[pos]
                            self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                            self.id_mirc_currentpos2.set_text(str(fmd.mirc_currentpos2))


        if (cam == "CHAMP"):
                print "Addressing CHAMP Camera, "
                if (fwheel == "1"):
                    print "Filterwheel 1, "
                    print "Pos = ",pos
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_champ_status1.set_text("Homing...")
			common.champF.homeFilters(1)		
                        fmd.champ_currentpos1= 0
                        fmd.champ_currentfilter1= "HOME"
                        self.id_champ_currentfilter1.set_text(fmd.champ_currentfilter1)
                        self.id_champ_currentpos1.set_text(str(fmd.champ_currentpos1))
                        self.id_champ_status1.set_text("")
                        # rest of code
                    if (pos > 0):
                        if pos == 5:
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="1D%s\r1G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
			    common.champF.moveFilters(1,self.newPosi[int(fwheel)-1])
			    fmd.champ_currentpos1 = self.newPosi[int(fwheel)-1]
                            fmd.champ_currentfilter1=fmd.champ1[pos]
			    self.id_champ_status1.set_text("")
			    self.id_champ_currentpos1.set_text(str(self.newPosi[int(fwheel)-1]))
			    self.id_champ_currentfilter1.set_text(fmd.champ_currentfilter1)
                        else:
                            print fmd.champ1[pos]
			    print fmd.champ_filter1[pos-1]
                            ser_string="1D%s\r1G\r" % str(fmd.champ_filter1[pos-1])
			    print ser_string
			    common.champF.moveFilters(1,fmd.champ_filter1[pos-1])
			    self.id_champ_status1.set_text("")
                            fmd.champ_currentpos1 = fmd.champ_filter1[pos-1]
                            fmd.champ_currentfilter1=fmd.champ1[pos]
                            self.id_champ_currentfilter1.set_text(fmd.champ_currentfilter1)
                            self.id_champ_currentpos1.set_text(str(fmd.champ_currentpos1))
                            

                if (fwheel == "2"):
                    print "Filterwheel 2, "
                    print "Pos = ",pos
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_champ_status1.set_text("Homing...")
                        common.champF.homeFilters(2)
                        fmd.champ_currentpos2= 0
                        fmd.champ_currentfilter2= "HOME"
                        self.id_champ_currentfilter2.set_text(fmd.champ_currentfilter2)
                        self.id_champ_currentpos2.set_text(str(fmd.champ_currentpos2))
                        self.id_champ_status1.set_text("")
                        # rest of code
                    if (pos > 0):
                        if pos == 5:
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="2D%s\r2G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
                            common.champF.moveFilters(2,self.newPosi[int(fwheel)-1])
                            fmd.champ_currentpos2 = self.newPosi[int(fwheel)-1]
                            fmd.champ_currentfilter2=fmd.champ2[pos]
                            self.id_champ_status1.set_text("")
                            self.id_champ_currentpos2.set_text(str(self.newPosi[int(fwheel)-1]))
                            self.id_champ_currentfilter2.set_text(fmd.champ_currentfilter2)
                        else:
                            print fmd.champ2[pos]
                            print fmd.champ_filter2[pos-1]
                            ser_string="2D%s\r2G\r" % str(fmd.champ_filter1[pos-1])
                            print ser_string
                            common.champF.moveFilters(2,fmd.champ_filter2[pos-1])
                            self.id_champ_status1.set_text("")
                            fmd.champ_currentpos2 = fmd.champ_filter2[pos-1]
                            fmd.champ_currentfilter2=fmd.champ2[pos]
                            self.id_champ_currentfilter2.set_text(fmd.champ_currentfilter2)
                            self.id_champ_currentpos2.set_text(str(fmd.champ_currentpos2))


                if (fwheel == "3"):
                    print "Filterwheel 2, "
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_champ_status1.set_text("Homing...")
                        common.champF.homeFilters(2)
                        fmd.champ_currentpos2= 0
                        fmd.champ_currentfilter2= "HOME"
                        self.id_champ_currentfilter2.set_text(fmd.champ_currentfilter2)
                        self.id_champ_currentpos2.set_text(str(fmd.champ_currentpos2))
                        self.id_champ_status1.set_text("")
                        # rest of code
                        
                    if (pos > 0):
                        print fmd.champ2[pos]
                        if pos == 5:                            
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="2D%s\r2G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
                            champ_port.write(ser_string)
                            champ_port.write("2LF\r\n")
                            print champ_port.readline()
                            print champ_port.readline()
                            champ_port.write("2PR\r\n")
                            print champ_port.readline()
                            print champ_port.read(13)
                        else:
                            ser_string="2D%s\r2G\r" % str(fmd.champ_filter2[pos-1])
                            champ_port.write(ser_string)
                            fmd.champ_currentpos2 = fmd.champ_filter2[pos-1]
                            fmd.champ_currentfilter2=fmd.champ2[pos]
                            self.id_champ_currentfilter2.set_text(fmd.champ_currentfilter2)
                            self.id_champ_currentpos2.set_text(str(fmd.champ_currentpos2))
                        

    def movef_combo(self,widget,cam,fwheel,pos):
        status = widget.get_active()

        if (status > 0):
            if (cam == "MIRC"):
                self.id_mirc_status1.set_text("Moving...")
                if (fwheel == '1'):
                    if (status != common.statusmirc1):
                        self.movef_cb(widget,cam,fwheel,status-1)
                        common.statusmirc1 = status
                if (fwheel == '2'):
                    if (status != common.statusmirc2):
                        self.movef_cb(widget,cam,fwheel,status-1)
                        common.statusmirc2 = status

            if (cam == "CHAMP"):
                self.id_champ_status1.set_text("Moving...")
                if (fwheel == '1'):
                    if (status != common.statuschamp1):
                        self.movef_cb(widget,cam,fwheel,status-1)
                        common.statuschamp1 = status
                if (fwheel == '2'):
                    if (status != common.statuschamp2):
                        self.movef_cb(widget,cam,fwheel,status-1)
                        common.statuschamp2 = status

        self.id_mirc_status1.set_text("")
        self.id_champ_status1.set_text("")
        widget.set_active(status)

                    
    def on_interactive_dialog_clicked(self, fwheel):
        name = "Filer wheel "+fwheel
        dialog = gtk.Dialog("Interactive Dialog", self, 0,
                (gtk.STOCK_OK, gtk.RESPONSE_OK,
                "QUIT", gtk.RESPONSE_CLOSE))

        hbox = gtk.HBox(False, 8)
        hbox.set_border_width(8)
        dialog.vbox.pack_start(hbox, False, False, 0)

        stock = gtk.image_new_from_stock(
                gtk.STOCK_DIALOG_QUESTION,
                gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(stock, False, False, 0)

        table = gtk.Table(2, 2)
        table.set_row_spacings(4)
        table.set_col_spacings(4)
        hbox.pack_start(table, True, True, 0)

        label = gtk.Label("Filter wheel 1")
        label.set_use_underline(True)
        table.attach(label, 0, 1, 0, 1)
        local_entry1 = gtk.Entry()
        local_entry1.set_text(self.newPosi[int(fwheel)-1])
        table.attach(local_entry1, 1, 2, 0, 1)
        label.set_mnemonic_widget(local_entry1)

        dialog.show_all()

        response = dialog.run()

        if response == gtk.RESPONSE_OK:
            self.newPosi[int(fwheel)-1] = local_entry1.get_text()
        dialog.destroy()

    def initf_cb(self,widget, cam):
        print "Initializing " , cam
        if (cam == "MIRC"):
            print "Filterwheel 1..."
            common.mircF.initFilters(1)

            print "Filterwheel 2..."
            common.mircF.initFilters(2)

        if (cam == "CHAMP"):
            print "Filterwheel 1..."
            common.champF.initFilters(1)

            print "Filterwheel 2..."
            common.champF.initFilters(2)
            
        
    def setupf_cb (self,widget, cam):
        print "Setup Parameters for %s\n" % cam


def main():
    f=fm()
    gtk.main()

if __name__ == '__main__':
    main()
